From 80251d4185048c6391b74abe96c754e8a536b35f Mon Sep 17 00:00:00 2001
From: Frederic Cambus <fred@statdns.com>
Date: Thu, 23 Mar 2023 15:19:38 +0000
Subject: [PATCH] Add support to readelf for the PT_OPENBSD_MUTABLE segment
 type.

binutils * readelf.c (get_segment_type): Handle PT_OPENBSD_MUTABLE segment type.
include  * elf/common.h (PT_OPENBSD_MUTABLE): Define.
---
 binutils/ChangeLog   | 5 +++++
 binutils/readelf.c   | 1 +
 include/ChangeLog    | 4 ++++
 include/elf/common.h | 1 +
 4 files changed, 11 insertions(+)

diff --git a/binutils/ChangeLog b/binutils/ChangeLog
index 10718ab1d67..a6932cba144 100644
--- a/binutils/ChangeLog
+++ b/binutils/ChangeLog
@@ -1,3 +1,8 @@
+2023-03-23  Frederic Cambus  <fred@statdns.com>
+
+	* readelf.c (get_segment_type): Handle PT_OPENBSD_MUTABLE segment
+	type.
+
 2023-03-14  Nick Clifton  <nickc@redhat.com>
 
 	PR 30227
diff --git a/binutils/readelf.c b/binutils/readelf.c
index 4c540302e22..a47cb0eda0a 100644
--- a/binutils/readelf.c
+++ b/binutils/readelf.c
@@ -4640,6 +4640,7 @@ get_segment_type (Filedata * filedata, unsigned long p_type)
     case PT_GNU_PROPERTY: return "GNU_PROPERTY";
     case PT_GNU_SFRAME: return "GNU_SFRAME";
 
+    case PT_OPENBSD_MUTABLE: return "OPENBSD_MUTABLE";
     case PT_OPENBSD_RANDOMIZE: return "OPENBSD_RANDOMIZE";
     case PT_OPENBSD_WXNEEDED: return "OPENBSD_WXNEEDED";
     case PT_OPENBSD_BOOTDATA: return "OPENBSD_BOOTDATA";
diff --git a/include/ChangeLog b/include/ChangeLog
index f694007aaee..b157251bea8 100644
--- a/include/ChangeLog
+++ b/include/ChangeLog
@@ -1,3 +1,7 @@
+2023-03-23  Frederic Cambus  <fred@statdns.com>
+
+	* elf/common.h (PT_OPENBSD_MUTABLE): Define.
+
 2023-01-03  Luis Machado  <luis.machado@arm.com>
 
 	* elf/common.h (NT_ARM_SSVE): Define.
diff --git a/include/elf/common.h b/include/elf/common.h
index 630d212bbb2..6f64f05890c 100644
--- a/include/elf/common.h
+++ b/include/elf/common.h
@@ -492,6 +492,7 @@
 #define PT_GNU_SFRAME	(PT_LOOS + 0x474e554) /* SFrame stack trace information */
 
 /* OpenBSD segment types.  */
+#define PT_OPENBSD_MUTABLE   (PT_LOOS + 0x5a3dbe5)  /* Like bss, but not immutable.  */
 #define PT_OPENBSD_RANDOMIZE (PT_LOOS + 0x5a3dbe6)  /* Fill with random data.  */
 #define PT_OPENBSD_WXNEEDED  (PT_LOOS + 0x5a3dbe7)  /* Program does W^X violations.  */
 #define PT_OPENBSD_BOOTDATA  (PT_LOOS + 0x5a41be6)  /* Section for boot arguments.  */
-- 
2.31.1

